std::unordered_set< _Value, _Hash, _Pred, _Alloc >(3cxx)

NAME
std::unordered_set< _Value, _Hash, _Pred, _Alloc > - A standard container composed of unique keys (containing at most one of each key value) in which the elements' keys are the elements themselves.

SYNOPSIS

  Public Types

typedef _Hashtable::allocator_type allocator_type
typedef _Hashtable::const_iterator const_iterator
typedef _Hashtable::const_local_iterator const_local_iterator
typedef _Hashtable::const_pointer const_pointer
typedef _Hashtable::const_reference const_reference
typedef _Hashtable::difference_type difference_type
typedef _Hashtable::hasher hasher
typedef _Hashtable::iterator iterator
typedef _Hashtable::key_equal key_equal
typedef _Hashtable::key_type key_type
Public typedefs.
typedef _Hashtable::local_iterator local_iterator
typedef _Hashtable::pointer pointer
Iterator-related typedefs.
typedef _Hashtable::reference reference
typedef _Hashtable::size_type size_type
typedef _Hashtable::value_type value_type

  Public Member Functions

unordered_set ()=default
Default constructor.
template<typename _InputIterator > unordered_set (_InputIterator __first, _InputIterator __last, size_type __n, const allocator_type &__a)
template<typename _InputIterator > unordered_set (_InputIterator __first, _InputIterator __last, size_type __n, const hasher &__hf, const allocator_type &__a)
template<typename _InputIterator > unordered_set (_InputIterator __first, _InputIterator __last, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_set from a range.
unordered_set (const allocator_type &__a)
Creates an unordered_set with no elements.
unordered_set (const unordered_set &)=default
Copy constructor.
unordered_set (const unordered_set &__uset, const allocator_type &__a)
unordered_set (initializer_list< value_type > __l, size_type __n, const allocator_type &__a)
unordered_set (initializer_list< value_type > __l, size_type __n, const hasher &__hf, const allocator_type &__a)
unordered_set (initializer_list< value_type > __l, size_type __n=0, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Builds an unordered_set from an initializer_list.
unordered_set (size_type __n, const allocator_type &__a)
unordered_set (size_type __n, const hasher &__hf, const allocator_type &__a)
unordered_set (size_type __n, const hasher &__hf=hasher(), const key_equal &__eql=key_equal(), const allocator_type &__a=allocator_type())
Default constructor creates no elements.
unordered_set (unordered_set &&)=default
Move constructor.
unordered_set (unordered_set &&__uset, const allocator_type &__a)
const_iterator begin () const noexcept
iterator begin () noexcept
local_iterator begin (size_type __n)
Returns a read-only (constant) iterator pointing to the first bucket element.
const_local_iterator begin (size_type __n) const
size_type bucket (const key_type &__key) const
size_type bucket_count () const noexcept
Returns the number of buckets of the unordered_set.
size_type bucket_size (size_type __n) const
const_iterator cbegin () const noexcept
const_local_iterator cbegin (size_type __n) const
const_iterator cend () const noexcept
const_local_iterator cend (size_type __n) const
void clear () noexcept
size_type count (const key_type &__x) const
Finds the number of elements.
template<typename... _Args> std::pair< iterator, bool > emplace (_Args &&... __args)
Attempts to build and insert an element into the unordered_set.
template<typename... _Args> iterator emplace_hint (const_iterator __pos, _Args &&... __args)
Attempts to insert an element into the unordered_set.
bool empty () const noexcept
Returns true if the unordered_set is empty.
const_iterator end () const noexcept
iterator end () noexcept
local_iterator end (size_type __n)
Returns a read-only (constant) iterator pointing to one past the last bucket elements.
const_local_iterator end (size_type __n) const
std::pair< iterator, iterator > equal_range (const key_type &__x)
Finds a subsequence matching given key.
std::pair< const_iterator, const_iterator > equal_range (const key_type &__x) const
size_type erase (const key_type &__x)
Erases elements according to the provided key.
iterator erase (const_iterator __first, const_iterator __last)
Erases a [__first,__last) range of elements from an unordered_set.
iterator erase (const_iterator __position)
Erases an element from an unordered_set.
iterator erase (iterator __position)
iterator find (const key_type &__x)
Tries to locate an element in an unordered_set.
const_iterator find (const key_type &__x) const
allocator_type get_allocator () const noexcept
Returns the allocator object used by the unordered_set.
hasher hash_function () const
Returns the hash functor object with which the unordered_set was constructed.
template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
A template function that attempts to insert a range of elements.
std::pair< iterator, bool > insert (const value_type &__x)
Attempts to insert an element into the unordered_set.
iterator insert (const_iterator __hint, const value_type &__x)
Attempts to insert an element into the unordered_set.
iterator insert (const_iterator __hint, value_type &&__x)
void insert (initializer_list< value_type > __l)
Attempts to insert a list of elements into the unordered_set.
std::pair< iterator, bool > insert (value_type &&__x)
key_equal key_eq () const
Returns the key comparison object with which the unordered_set was constructed.
float load_factor () const noexcept
Returns the average number of elements per bucket.
size_type max_bucket_count () const noexcept
Returns the maximum number of buckets of the unordered_set.
float max_load_factor () const noexcept
Returns a positive number that the unordered_set tries to keep the load factor less than or equal to.
void max_load_factor (float __z)
Change the unordered_set maximum load factor.
size_type max_size () const noexcept
Returns the maximum size of the unordered_set.
unordered_set & operator= (const unordered_set &)=default
Copy assignment operator.
unordered_set & operator= (initializer_list< value_type > __l)
Unordered_set list assignment operator.
unordered_set & operator= (unordered_set &&)=default
Move assignment operator.
void rehash (size_type __n)
May rehash the unordered_set.
void reserve (size_type __n)
Prepare the unordered_set for a specified number of elements.
size_type size () const noexcept
Returns the size of the unordered_set.
void swap (unordered_set &__x) noexcept(noexcept(_M_h.swap(__x._M_h)))
Swaps data with another unordered_set.

  Friends

template<typename _Value1 , typename _Hash1 , typename _Pred1 , typename _Alloc1 > bool operator== (const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &, const unordered_set< _Value1, _Hash1, _Pred1, _Alloc1 > &)

Detailed Description

  template<typename _Value, typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>>
class std::unordered_set< _Value, _Hash, _Pred, _Alloc >" A standard container composed of unique keys (containing at most one of each key value) in which the elements' keys are the elements themselves.

Template Parameters
    _Value Type of key objects.
    _Hash Hashing function object type, defaults to hash<_Value>.
    _Pred Predicate function object type, defaults to equal_to<_Value>.
    _Alloc Allocator type, defaults to allocator<_Key>.

Meets the requirements of a container, and unordered associative container

Base is _Hashtable, dispatched at compile time via template alias __uset_hashtable.

Definition at line 97 of file unordered_set.h.

Member Typedef Documentation

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> typedef _Hashtable::key_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_type

Public typedefs.

Definition at line 106 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> typedef _Hashtable::pointer std::unordered_set< _Value, _Hash, _Pred, _Alloc >::pointer

Iterator-related typedefs.

Definition at line 115 of file unordered_set.h.

Constructor & Destructor Documentation

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set () [default]

Default constructor.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (size_type __n, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline], [explicit]

Default constructor creates no elements.

Parameters
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Definition at line 145 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> template<typename _InputIterator > std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (_InputIterator __first, _InputIterator __last, size_type __n = 0, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline]

Builds an unordered_set from a range.

Parameters
    __first An input iterator.
    __last An input iterator.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_set consisting of copies of the elements from [__first,__last). This is linear in N (where N is distance(__first,__last)).

Definition at line 166 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (const unordered_set< _Value, _Hash, _Pred, _Alloc > &) [default]

Copy constructor.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (unordered_set< _Value, _Hash, _Pred, _Alloc > &&) [default]

Move constructor.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (const allocator_type & __a) [inline], [explicit]

Creates an unordered_set with no elements.

Parameters
    __a An allocator object.

Definition at line 185 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::unordered_set (initializer_list< value_type > __l, size_type __n = 0, const hasher & __hf = hasher(), const key_equal & __eql = key_equal(), const allocator_type & __a = allocator_type()) [inline]

Builds an unordered_set from an initializer_list.

Parameters
    __l An initializer_list.
    __n Minimal initial number of buckets.
    __hf A hash functor.
    __eql A key equality functor.
    __a An allocator object.

Create an unordered_set consisting of copies of the elements in the list. This is linear in N (where N is __l.size()).

Definition at line 220 of file unordered_set.h.

Member Function Documentation

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin () [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 319 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::begin (size_type __n) [inline]

Returns a read-only (constant) iterator pointing to the first bucket element.

Parameters
    __n The bucket index.

Returns
    A read-only local iterator.

Definition at line 726 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::bucket_count () const [inline], [noexcept]

Returns the number of buckets of the unordered_set.

Definition at line 692 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the unordered_set.

Definition at line 346 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> const_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 354 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::clear () [inline], [noexcept]
Erases all elements in an unordered_set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 572 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::count (const key_type & __x) const [inline]

Finds the number of elements.

Parameters
    __x Element to located.

Returns
    Number of elements with specified key.

This function only makes sense for unordered_multisets; for unordered_set the result will either be 0 (not present) or 1 (present).

Definition at line 667 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> template<typename... _Args> std::pair<iterator, bool> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace (_Args &&... __args) [inline]

Attempts to build and insert an element into the unordered_set.

Parameters
    __args Arguments used to generate an element.

Returns
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to build and insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 376 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> template<typename... _Args> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::emplace_hint (const_iterator __pos, _Args &&... __args) [inline]

Attempts to insert an element into the unordered_set.

Parameters
    __pos An iterator that serves as a hint as to where the element should be inserted.
    __args Arguments used to generate the element to be inserted.

Returns
    An iterator that points to the element with key equivalent to the one generated from __args (may or may not be the element itself).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument emplace() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant time.

Definition at line 402 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> bool std::unordered_set< _Value, _Hash, _Pred, _Alloc >::empty () const [inline], [noexcept]

Returns true if the unordered_set is empty.

Definition at line 298 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end () [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the unordered_set.

Definition at line 333 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> local_iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::end (size_type __n) [inline]

Returns a read-only (constant) iterator pointing to one past the last bucket elements.

Parameters
    __n The bucket index.

Returns
    A read-only local iterator.

Definition at line 746 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::pair<iterator, iterator> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::equal_range (const key_type & __x) [inline]

Finds a subsequence matching given key.

Parameters
    __x Key to be located.

Returns
    Pair of iterators that possibly points to the subsequence matching given key.

This function probably only makes sense for multisets.

Definition at line 680 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const key_type & __x) [inline]

Erases elements according to the provided key.

Parameters
    __x Key of element to be erased.

Returns
    The number of elements erased.

This function erases all the elements located by the given key from an unordered_set. For an unordered_set the result of this function can only be 0 (not present) or 1 (present). Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 544 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const_iterator __first, const_iterator __last) [inline]

Erases a [__first,__last) range of elements from an unordered_set.

Parameters
    __first Iterator pointing to the start of the range to be erased.
    __last Iterator pointing to the end of the range to be erased.

Returns
    The iterator __last.

This function erases a sequence of elements from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 562 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::erase (const_iterator __position) [inline]

Erases an element from an unordered_set.

Parameters
    __position An iterator pointing to the element to be erased.

Returns
    An iterator pointing to the element immediately following __position prior to the element being erased. If no such element exists, end() is returned.

This function erases an element, pointed to by the given iterator, from an unordered_set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 522 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::find (const key_type & __x) [inline]

Tries to locate an element in an unordered_set.

Parameters
    __x Element to be located.

Returns
    Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( end() ) iterator.

Definition at line 649 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> allocator_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::get_allocator () const [inline], [noexcept]

Returns the allocator object used by the unordered_set.

Definition at line 291 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> hasher std::unordered_set< _Value, _Hash, _Pred, _Alloc >::hash_function () const [inline]

Returns the hash functor object with which the unordered_set was constructed.

Definition at line 625 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> template<typename _InputIterator > void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (_InputIterator __first, _InputIterator __last) [inline]

A template function that attempts to insert a range of elements.

Parameters
    __first Iterator pointing to the start of the range to be inserted.
    __last Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Definition at line 468 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> std::pair<iterator, bool> std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (const value_type & __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters
    __x Element to be inserted.

Returns
    A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the unordered_set. An unordered_set relies on unique keys and thus an element is only inserted if it is not already present in the unordered_set.

Insertion requires amortized constant time.

Definition at line 420 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> iterator std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (const_iterator __hint, const value_type & __x) [inline]

Attempts to insert an element into the unordered_set.

Parameters
    __hint An iterator that serves as a hint as to where the element should be inserted.
    __x Element to be inserted.

Returns
    An iterator that points to the element with key of __x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

For more on hinting, see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/associative.html#containers.associative.insert_hints

Insertion requires amortized constant.

Definition at line 449 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::insert (initializer_list< value_type > __l) [inline]

Attempts to insert a list of elements into the unordered_set.

Parameters
    __l A std::initializer_list<value_type> of elements to be inserted.

Complexity similar to that of the range constructor.

Definition at line 479 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> key_equal std::unordered_set< _Value, _Hash, _Pred, _Alloc >::key_eq () const [inline]

Returns the key comparison object with which the unordered_set was constructed.

Definition at line 631 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::load_factor () const [inline], [noexcept]

Returns the average number of elements per bucket.

Definition at line 762 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_bucket_count () const [inline], [noexcept]

Returns the maximum number of buckets of the unordered_set.

Definition at line 697 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> float std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor () const [inline], [noexcept]

Returns a positive number that the unordered_set tries to keep the load factor less than or equal to.

Definition at line 768 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_load_factor (float __z) [inline]

Change the unordered_set maximum load factor.

Parameters
    __z The new maximum load factor.

Definition at line 776 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::max_size () const [inline], [noexcept]

Returns the maximum size of the unordered_set.

Definition at line 308 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (const unordered_set< _Value, _Hash, _Pred, _Alloc > &) [default]

Copy assignment operator.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (initializer_list< value_type > __l) [inline]

Unordered_set list assignment operator.

Parameters
    __l An initializer_list.

This function fills an unordered_set with copies of the elements in the initializer list __l.

Note that the assignment completely changes the unordered_set and that the resulting unordered_set's size is the same as the number of elements assigned.

Definition at line 283 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> unordered_set& std::unordered_set< _Value, _Hash, _Pred, _Alloc >::operator= (unordered_set< _Value, _Hash, _Pred, _Alloc > &&) [default]

Move assignment operator.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::rehash (size_type __n) [inline]

May rehash the unordered_set.

Parameters
    __n The new number of buckets.

Rehash will occur only if the new number of buckets respect the unordered_set maximum load factor.

Definition at line 787 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::reserve (size_type __n) [inline]

Prepare the unordered_set for a specified number of elements.

Parameters
    __n Number of elements required.

Same as rehash(ceil(n / max_load_factor())).

Definition at line 798 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> size_type std::unordered_set< _Value, _Hash, _Pred, _Alloc >::size () const [inline], [noexcept]

Returns the size of the unordered_set.

Definition at line 303 of file unordered_set.h.

  template<typename _Value , typename _Hash = hash<_Value>, typename _Pred = equal_to<_Value>, typename _Alloc = allocator<_Value>> void std::unordered_set< _Value, _Hash, _Pred, _Alloc >::swap (unordered_set< _Value, _Hash, _Pred, _Alloc > & __x) [inline], [noexcept]

Swaps data with another unordered_set.

Parameters
    __x An unordered_set of the same element and allocator types.

This exchanges the elements between two sets in constant time. Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Definition at line 585 of file unordered_set.h.

Author

Generated automatically by Doxygen for libstdc++ from the source code.